grammar debugMeWithAntlrWorks;
 options{backtrack=true; memoize=true;} 



parse :
	 result=ruleModel EOF
;

ruleModel  :
(temp_types=ruleType )*
;

ruleType  :
        temp_datatype=ruleDataType 	|        temp_entity=ruleEntity 	;

ruleDataType  :
(('datatype')

(temp_name=RULE_ID )
)
;

ruleEntity  :
(('entity')

(temp_name=RULE_ID )

('{')

(temp_features=ruleFeature )*

('}')
)
;

ruleFeature  :
((temp_type=RULE_ID
)

(temp_name=RULE_ID )
)
;

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'"') )* '"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

